%define name    torque
%define version 2.4.8
%define release %mkrel 1
%define lib_name_orig lib%{name}
%define major           2
%define	libname	%mklibname %{name} %{major}
%define	devname	%mklibname -d %{name}

%define tcl_sitelib_spaced %(echo %tcl_sitelib | sed -e 's,/, ,g')

Name:           %{name}
Summary:        The Portable Batch System
Group:		System/Cluster
Version:        %{version}
Release:        %{release}
License:        OpenPBS
URL:            http://www.clusterresources.com/products/torque-resource-manager.php
Requires:       openssh-clients >= 2.9
Provides:       OpenPBS
BuildRoot:      %{_tmppath}/%{name}-%{version}
Source0:        %{name}-%{version}.tar.gz
Source1:	pbs_server
Source2:	pbs.conf	
Source3:	PBS_doc_v2.3_admin.pdf
Source4:        pbs_mom
Source5:        pbs_sched
Source6:	xpbs
Source7:	xpbsmon
Source8:	tclIndex_xpbsmon
Source9:	tclIndex_xpbs
Source10:	introduction_openPBS
Source11:	xtermPBSlog
Source12:	pbs
Source13:	setup_pbs_server
Source14:	pbs_config.sample
Source15:	pbs_para_job.sh	
Source17:	pbs-epilogue
Source18:	pbs-prologue
Source19:	setup_pbs_client
Patch13:	torque-2.1.11-destdir.patch
Patch14:	torque-2.3.7-tcl86.patch
BuildRequires:	tk >= 8.3 tk-devel >= 8.3 
BuildRequires:	tcl >= 8.3 tcl-devel >= 8.3
BuildRequires:	openssh openssh-clients
BuildRequires:	X11-devel readline-devel
Provides:	OpenPBS
Obsoletes:	OpenPBS
Requires(post): rpm-helper
Requires(preun): rpm-helper

%description
The Portable Batch System (PBS) is a flexible batch software
processing system developed at NASA Ames Research Center. It 
operates on networked, multi-platform UNIX environments, 
including heterogeneous clusters of workstations, supercomputers,
and massively parallel systems.

"This product includes software developed by NASA Ames Research 
Center, Lawrence Livermore National Laboratory, and Veridian 
Information Solutions, Inc. Visit www.OpenPBS.org for OpenPBS 
software support,products, and information."

%package -n	%{libname}
Summary:	Library for %{name}
Group:		System/Libraries

%description -n	%{libname}
Library for %{name}.

%package -n	%{devname}
Summary:	The Portable Batch System (PBS) devel 
Group:		Development/Other
Requires:	%{libname} = %{version}
Provides:	%{_lib}%{name}1-devel = %{version}-%{release}
Obsoletes:	%{_lib}%{name}1-devel
Provides:	lib%name-devel = %version-%release
Provides:	%name-devel = %version-%release

%description -n %{devname}
The Portable Batch System (PBS) function prototype.
"This product includes software developed by NASA Ames Research 
Center, Lawrence Livermore National Laboratory, and Veridian 
Information Solutions, Inc. Visit www.OpenPBS.org for OpenPBS 
software support,products, and information."

%package	client
Summary:	The Portable Batch System (PBS) client
Requires:       openssh-clients >= 2.9
Group:		System/Cluster
Provides:	OpenPBS-client
Obsoletes:	OpenPBS-client
Requires(post): rpm-helper
Requires(preun): rpm-helper

%description	client
The Portable Batch System (PBS) client.
"This product includes software developed by NASA Ames Research 
Center, Lawrence Livermore National Laboratory, and Veridian 
Information Solutions, Inc. Visit www.OpenPBS.org for OpenPBS 
software support,products, and information."

%package        xpbs
Requires:	tk >= 8.3, tcl >= 8.3, %{name}-client = %{version}-%{release}
Summary:        The Portable Batch System (PBS) X interface 
Group:          Monitoring
Provides:	OpenPBS-xpbs
Obsoletes:	OpenPBS-xpbs

%description	xpbs
The Portable Batch System (PBS) X interface.
"This product includes software developed by NASA Ames Research 
Center, Lawrence Livermore National Laboratory, and Veridian 
Information Solutions, Inc. Visit www.OpenPBS.org for OpenPBS 
software support,products, and information."

%prep
%setup -q
%patch13 -p1 -b .destdir~
%if %{mdkversion} >= 200910
%patch14 -p1 -b .tcl86~
%endif

# these variables aren't ever set in any file that gets installed,
# so without doing this, xpbs won't run - AdamW 2008/12
sed -i -e 's,$xpbs_datadump,xpbs_datadump,g' src/gui/pbs.tcl
sed -i -e 's,$xpbs_scriptload,xpbs_scriptload,g' src/gui/pbs.tcl

cp %{SOURCE3} $RPM_BUILD_DIR/%{name}-%{version}/PBS_doc_v2.3_admin.pdf
cp %{SOURCE10} $RPM_BUILD_DIR/%{name}-%{version}/introduction_openPBS
cp %{SOURCE15} $RPM_BUILD_DIR/%{name}-%{version}/para_job_pbs.sh

%pre 
/usr/sbin/groupadd -g 12386 -r -f pbs > /dev/null 2>&1 ||:
# /usr/sbin/useradd -g pbs -d %{pbs_user} -r -s /bin/bash -p "" -m >/dev/null 2>&1 ||:

%pre client
/usr/sbin/groupadd -g 12386 -r -f pbs > /dev/null 2>&1 ||:

%build
CFLAGS="%{optflags} -std=gnu99" \
%configure2_5x \
	--with-rcp=scp \
	--with-server-home=/var/spool/pbs \
	--enable-docs \
	--enable-server \
	--enable-mom \
	--enable-client \
	--srcdir=${RPM_BUILD_DIR}/%{name}-%{version} \
	--enable-gui \
	-x-libraries=%_libdir
	
%ifarch x86_64
	perl -pi -e 's|\-L\$\(TCL\_DIR\)/lib|\-L\$\(TCL\_DIR\)/lib64|g' src/tools/Makefile
%endif 

#make depend
make clean
%make all XPBS_DIR=%{tcl_sitelib}/xpbs XPBSMON_DIR=%{tcl_sitelib}/xpbsmon

%install
rm -rf %{buildroot}
pbs_server_home_for_install=%{buildroot}/var/spool/pbs

mkdir -p %{buildroot}%{_initrddir}
mkdir -p ${pbs_server_home_for_install}/mom_priv/
touch ${pbs_server_home_for_install}/mom_priv/config
mkdir -p ${pbs_server_home_for_install}/sched_priv
chmod 644 ${pbs_server_home_for_install}/mom_priv/config
mkdir -p ${pbs_server_home_for_install}/server_logs
mkdir -p ${pbs_server_home_for_install}/sched_logs
mkdir -p ${pbs_server_home_for_install}/server_priv

mkdir -p %{buildroot}%{_defaultdocdir}
mkdir -p %{buildroot}%{_sysconfdir}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{tcl_sitelib}/xpbs
mkdir -p %{buildroot}%{tcl_sitelib}/xpbsmon
mkdir -p %{buildroot}%{_libdir}/%{name}-%{version}
mkdir -p %{buildroot}%{_defaultdocdir}/%{name}-%{version}
mkdir -p %{buildroot}%{_defaultdocdir}/%{name}-client-%{version}
mkdir -p %{buildroot}%{_includedir}/%{name}-%{version}

install -m755 %{SOURCE1} %{buildroot}%{_initrddir}/pbs_server
install -m755 %{SOURCE4} %{buildroot}%{_initrddir}/pbs_mom
install -m755 %{SOURCE5} %{buildroot}%{_initrddir}/pbs_sched
install -m755 %{SOURCE12} %{buildroot}%{_initrddir}/openpbs
install -m644 %{SOURCE2} %{buildroot}%{_sysconfdir}/pbs.conf
install -m644 %{SOURCE11} %{buildroot}%{_sbindir}/pbslogs

%makeinstall_std PBS_SERVER_HOME=/var/spool/pbs mandir=%_mandir XPBS_DIR=%{tcl_sitelib}/xpbs XPBSMON_DIR=%{tcl_sitelib}/xpbsmon

mkdir -p %{buildroot}%{_sbindir}
chmod 755 %{buildroot}%{_sbindir}/pbs_mom
chmod 755 %{buildroot}%{_sbindir}/pbs_sched
chmod 755 %{buildroot}%{_sbindir}/pbs_iff
#chmod 755 %{buildroot}%{_sbindir}/pbs_rcp
chmod 755 %{buildroot}%{_sbindir}/pbs_server
chmod 755 %{buildroot}%{_initrddir}/openpbs

# needed to overwrite bad path in those scripts
install -m755 %{SOURCE6} %{buildroot}%{_bindir}/xpbs
install -m755 %{SOURCE7} %{buildroot}%{_bindir}/xpbsmon
install -m755 %{SOURCE13} %{buildroot}%{_bindir}/setup_pbs_server
install -m755 %{SOURCE19} %{buildroot}%{_bindir}/setup_pbs_client
install -m644 %{SOURCE8} %{buildroot}%{tcl_sitelib}/xpbsmon/tclIndex
install -m644 %{SOURCE9} %{buildroot}%{tcl_sitelib}/xpbs/tclIndex
install -m644 %{SOURCE14} %{buildroot}%{_var}/spool/pbs/pbs_config.sample
install -m755 %{SOURCE17} %{buildroot}%{_var}/spool/pbs/mom_priv/epilogue
install -m755 %{SOURCE18} %{buildroot}%{_var}/spool/pbs/mom_priv/prologue

# replace the placeholder text with whatever the real tcl_sitelib
# should be...cunning, eh? - AdamW 2008/12
sed -i -e 's,TCL_SITELIB,%{tcl_sitelib},g' \
%{buildroot}%{tcl_sitelib}/xpbsmon/tclIndex \
%{buildroot}%{tcl_sitelib}/xpbs/tclIndex \
%{buildroot}%{_bindir}/xpbs \
%{buildroot}%{_bindir}/xpbsmon \
%{buildroot}%{_bindir}/setup_pbs_server \
%{buildroot}%{_bindir}/setup_pbs_client

rm -f %{buildroot}%{_libdir}/xpbs/tclIndex
rm -f %{buildroot}%{_libdir}/xpbsmon/tclIndex

echo "# MOM server configuration file" > ${pbs_server_home_for_install}/mom_priv/config
echo "# if more than one value, separate it by comma." >> ${pbs_server_home_for_install}/mom_priv/config

cp -av $RPM_BUILD_DIR/%{name}-%{version}/src/include/* %{buildroot}%{_includedir}/%{name}-%{version}/

perl -pi -e 's/wish8\.3/wish/' %buildroot%_bindir/xpbs

%multiarch_includes $RPM_BUILD_ROOT%{_includedir}/%{name}-%{version}/pbs_config.h

%clean
rm -rf ${RPM_BUILD_ROOT}

%post
#!/bin/sh
pbs_prefix=%_prefix
pbs_server_home=/var/spool/pbs
if [ -f "${pbs_server_home}/server_name" ]; then
        echo `hostname` > ${pbs_server_home}/server_name
fi
#if [ ! -f "${pbs_server_home}/default_server" ] ; then
#        echo "# <server hostname>" > ${pbs_server_home}/default_server
#fi
if [ -f "${pbs_server_home}/default_server" ]; then
        echo `hostname` >> ${pbs_server_home}/default_server
fi
if [ ! -f "${pbs_server_home}/server_priv/nodes" ]; then
	echo `hostname` > ${pbs_server_home}/server_priv/nodes
fi

# add pbs service
%_post_service pbs_server
# %_post_service pbs_sched

# mise a jour /etc/services if needed
CHECK_PORT=`grep 15003 /etc/services`
if [ -z "$CHECK_PORT" ]; then
	cat >> /etc/services << EOF
# Port needed by PBS
pbs_server	15001/tcp	# pbs server
pbs_mom		15002/tcp	# mom to/from server
pbs_resmon	15003/tcp   # mom resource management requests
pbs_resmon      15003/udp   # mom resource management requests
pbs_sched	15004/tcp   # scheduler 
EOF
fi
	
%post client
%_post_service pbs_mom

%post xpbs
ln -sf %{tcl_sitelib}/xpbs /usr/lib/xpbs
ln -sf %{tcl_sitelib}/xpbsmon /usr/lib/xpbsmon

%preun
%_preun_service pbs_server

%preun client
%_preun_service pbs_mom

%if %mdkversion < 200900
%postun -p /sbin/ldconfig
%endif

%files
%defattr(-,root,root)
%doc doc/READ_ME PBS_License.txt 
%{_mandir}/man1/pbs*
%{_mandir}/man3/pbs*
%{_mandir}/man7/*
%{_mandir}/man8/pbsnodes*
%{_mandir}/man8/pbs_server.8*
%{_mandir}/man8/pbs_sch*
%config(noreplace) %{_sysconfdir}/pbs.conf
%defattr(755, root, root)
%{_initrddir}/pbs_server
%{_initrddir}/pbs_sched
%{_initrddir}/openpbs
%{_sbindir}/pbs_server
%{_sbindir}/pbs_sched
%{_sbindir}/pbslogs
%{_sbindir}/qnoded
%{_sbindir}/qschedd
%{_sbindir}/qserverd
%{_bindir}/pbs_track
%{_bindir}/pbsnodes
%{_bindir}/setup_pbs_server
%{_bindir}/pbs-config
%{_bindir}/printtracking
%{_bindir}/printserverdb

%{_var}/spool/pbs/sched_logs/
%dir %{_var}/spool/pbs
%{_var}/spool/pbs/sched_priv
%{_var}/spool/pbs/server_logs/
%{_var}/spool/pbs/checkpoint/
%{_var}/spool/pbs/server_priv/
%attr(775,root,pbs) %{_var}/spool/pbs/spool/
%attr(1777,root,pbs) %{_var}/spool/pbs/undelivered/
%config(noreplace) %{_var}/spool/pbs/pbs_environment
%config(noreplace) %{_var}/spool/pbs/server_name
%{_var}/spool/pbs/pbs_config.sample

%files client
%defattr(-,root,root)
%doc PBS_doc_v2.3_admin.pdf introduction_openPBS para_job_pbs.sh PBS_License.txt
%config(noreplace) %{_sysconfdir}/pbs.conf
%{_mandir}/man1/q*
%{_mandir}/man8/q*
%{_mandir}/man8/pbsnodes*
%{_mandir}/man8/pbs_mom.8*
%{_mandir}/man1/bas*
%{_mandir}/man1/nqs*
%dir %{_var}/spool/pbs
%{_var}/spool/pbs/mom_logs
%{_var}/spool/pbs/mom_priv
%{_var}/spool/pbs/aux
%{_var}/spool/pbs/checkpoint
%attr(1777,root,pbs) %{_var}/spool/pbs/undelivered
%attr(775,root,pbs) %{_var}/spool/pbs/spool
%config(noreplace) %{_var}/spool/pbs/pbs_environment
%{_bindir}/q*
%{_bindir}/chk_tree
%{_bindir}/hostn
%{_bindir}/nqs2pbs
%{_bindir}/printjob
%{_bindir}/tracejob
%{_bindir}/pbsnodes
%{_bindir}/pbsdsh
%{_bindir}/setup_pbs_client
%{_sbindir}/momctl
%{_sbindir}/pbs_demux
%attr(4755,root,root) %{_sbindir}/pbs_iff
%{_sbindir}/pbs_mom
%{_initrddir}/pbs_mom
%config(noreplace) %{_var}/spool/pbs/server_name

%files -n %{libname}
%{_libdir}/*.so.%{major}*

%files -n %{devname}
%defattr(-,root,root)
%doc PBS_License.txt
%{_libdir}/*.la
%{_libdir}/*.so
%{_libdir}/*.a
%{_mandir}/man3/tm*
%{_mandir}/man3/rpp.3.*
%{_includedir}/%{name}-%{version}
%{_includedir}/*.h
%multiarch %{multiarch_includedir}/%{name}-%{version}/pbs_config.h

%files xpbs
%defattr(-,root,root)
%doc PBS_License.txt
%{_bindir}/pbs_tclsh
%{_bindir}/pbs_wish
%{_bindir}/xpbsmon
%{_bindir}/xpbs
%dir %{tcl_sitelib}/xpbs/bitmaps
%{tcl_sitelib}/xpbs/bitmaps/*
%dir %{tcl_sitelib}/xpbs/help
%{tcl_sitelib}/xpbs/help/*
%dir %{tcl_sitelib}/xpbs/bin
%{tcl_sitelib}/xpbs/bin/*
%{tcl_sitelib}/xpbs/preferences.tcl
%{tcl_sitelib}/xpbs/pbs.tcl
%{tcl_sitelib}/xpbs/*.tk
%{tcl_sitelib}/xpbs/tclIndex
%config(noreplace) %{tcl_sitelib}/xpbs/xpbsrc
%{tcl_sitelib}/xpbs/buildindex
%{tcl_sitelib}/xpbsmon/buildindex
%{tcl_sitelib}/xpbsmon/*.tk
%{tcl_sitelib}/xpbsmon/*.tcl
%{tcl_sitelib}/xpbsmon/tclIndex
%config(noreplace) %{tcl_sitelib}/xpbsmon/xpbsmonrc
%dir %{tcl_sitelib}/xpbsmon
%dir %{tcl_sitelib}/xpbsmon/bitmaps
%{tcl_sitelib}/xpbsmon/bitmaps/*
%{tcl_sitelib}/xpbsmon/help/*
%{_mandir}/man1/x*




%changelog
* Mon May 10 2010 Antoine Ginies <aginies@mandriva.com> 2.4.8-1mdv2010.1
+ Revision: 544318
- release 2.4.8

* Tue Feb 09 2010 Antoine Ginies <aginies@mandriva.com> 2.4.5-1mdv2010.1
+ Revision: 502714
- release 2.4.5

  + Giuseppe Ghibò <ghibo@mandriva.com>
    - Let Patch14 for TCL 8.6 conditional (needed for backporting over older tcl versions).

* Thu Jul 23 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.3.7-1mdv2010.0
+ Revision: 398757
- bump major
- place library in it's own separate package rather than in the devel package
- cleanups
- regenerate P14
- drop dead patches
- new release: 2.3.7
- add readline-devel to buildrequires
- use %%configure2_5x macro
- fix string format issues (P0)
- regenarate P9, P13, P14
- drop Prefix tag
- drop unused patches
- new release: 2.1.11

* Sat Dec 06 2008 Adam Williamson <awilliamson@mandriva.org> 2.1.7-6mdv2009.1
+ Revision: 310969
- rebuild for new tcl
- install to new location per policy
- make sure everything's on the same page with regards to /var/spool/pbs
- fix a code bug that prevents xpbs running
- add tcl86.patch (fix/kludge build for tcl 8.6)
- fix a #%%define

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild
    - rebuild

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Fri Dec 21 2007 Olivier Blin <oblin@mandriva.com> 2.1.7-3mdv2008.1
+ Revision: 136550
- restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request
    - buildrequires X11-devel instead of XFree86-devel
    - kill packager tag

* Fri Sep 07 2007 Anssi Hannula <anssi@mandriva.org> 2.1.7-3mdv2008.0
+ Revision: 82052
- rebuild for new soname of tcl

* Fri Jun 22 2007 Thierry Vignaud <tv@mandriva.org> 2.1.7-2mdv2008.0
+ Revision: 42958
- uncompress a patch, thus fixing build
- fix group


* Tue Feb 27 2007 Olivier Thauvin <nanardon@mandriva.org> 2.1.7-1mdv2007.0
+ Revision: 126203
- fix buildrequirements
- clean up patch
- fix path installation
- 2.1.7

  + Lev Givon <lev@mandriva.org>
    - Import torque

* Wed Jan 04 2006 Oden Eriksson <oeriksson@mandriva.com> 2.0.0-2mdk
- rebuilt against soname aware deps (tcl/tk)
- fix deps

* Thu Nov 17 2005 Antoine Ginies <aginies@n3.mandriva.com> 2.0.0-1mdk
- release 2.0.0p1

* Thu Mar 17 2005 Antoine Ginies <aginies@mandrakesoft.com> 1.2.0-1mdk
- release 1.2.0p1
- fix acces to xpbs and xpbsmon

* Tue Jun 22 2004 Erwan Velu <erwan@mandrakesoft.com> 1.1.0-1mdk
- 1.1.0

* Thu May 06 2004 Erwan Velu <erwan@mandrakesoft.com> 1.0.1-7mdk
- Fixing wrong rights on /usr/include/torque

* Thu Apr 22 2004 Erwan Velu <erwan@mandrakesoft.com> 1.0.1-6mdk
- Adding Torque1.0.1p6-comment.diff

* Tue Apr 20 2004 Erwan Velu <erwan@mandrakesoft.com> 1.0.1-5mdk
- Release p6
- Adding %%subrelease to builddir

* Tue Mar 02 2004 Olivier Thauvin <thauvin@aerov.jussieu.fr> 1.0.1-4mdk
- Fix DIRM (distlint)
- Fix dep wish8.3

* Mon Mar 01 2004 Olivier Thauvin <thauvin@aerov.jussieu.fr> 1.0.1-3mdk
- fix -devel provides

* Mon Mar 01 2004 Olivier Thauvin <thauvin@aerov.jussieu.fr> 1.0.1-2mdk
- Provides/Obsoletes: PBS

